/***************************************************************************
                          ksubeditordoc.h  -  description
                             -------------------
    begin                : pi sty 10 21:05:38 CET 2003
    copyright            : (C) 2003 by Anatol Ogrek
    email                : mroova@linux.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define SUB_INVALID   -1
 
#ifndef KSUBEDITORDOC_H
#define KSUBEDITORDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>
#include <qpopupmenu.h>

// include files for KDE
#include <kurl.h>
//other includes
#include "subtitles.h"
// forward declaration of the Ksubeditor classes
class KsubeditorView;

/**	KsubeditorDoc provides a document object for a document-view model.
  *
  * The KsubeditorDoc class provides a document object that can be used in conjunction with the classes
  * KsubeditorApp and KsubeditorView to create a document-view model for MDI (Multiple Document Interface)
  * KDE 2 applications based on KApplication and KTMainWindow as main classes and QWorkspace as MDI manager widget.
  * Thereby, the document object is created by the KsubeditorApp instance (and kept in a document list) and contains
  * the document structure with the according methods for manipulating the document
  * data by KsubeditorView objects. Also, KsubeditorDoc contains the methods for serialization of the document data
  * from and to files.
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 1.3 code generation
  */
class KsubeditorDoc : public QObject
{
  Q_OBJECT

//  friend KsubeditorView;

  public:
    /** Constructor for the fileclass of the application */
    KsubeditorDoc();
    /** Destructor for the fileclass of the application */
    ~KsubeditorDoc();

    /** adds a view to the document which represents the document contents. Usually this is your main view. */
    void addView(KsubeditorView *view);
    /** removes a view from the list of currently connected views */
    void removeView(KsubeditorView *view);
		/** gets called if a view is removed or added */
		void changedViewList();
    /** returns the first view instance */
		KsubeditorView* firstView(){ return pViewList->first(); };
		/** returns true, if the requested view is the last view of the document */
    bool isLastView();
    /** This method gets called when the user is about to close a frame window. It checks, if more than one view
    	* is connected to the document (then the frame can be closed), if pFrame is the last view and the document is
    	* modified, the user gets asked if he wants to save the document.
    	*/
		bool canCloseFrame(KsubeditorView* pFrame);
    /** sets the modified flag for the document after a modifying action on the view connected to the document.*/
    void setModified(bool _m=true){ modified=_m; };
    /** returns if the document is modified or not. Use this to determine if your document needs saving by the user on closing.*/
    bool isModified(){ return modified; };
    /** deletes the document's contents */
    void deleteContents();
    /** initializes the document generally */
    bool newDocument();
    /** closes the acutal document */
    void closeDocument();
    /** loads the document by filename and format and emits the updateViews() signal */
    bool openDocument(const KURL &url,int format = SUB_INVALID);
    /** saves the document under filename and format.*/	
    bool saveDocument(const KURL &url,bool temp = false);
    /** returns the KURL of the document */
    const KURL& URL() const;
    /** sets the URL of the document */
	  void setURL(const KURL& url);
	
  public slots:
    /** calls repaint() on all views connected to the document object and is called by the view by which the document has been changed.
     * As this view normally repaints itself, it is excluded from the paintEvent.
     */
    void updateAllViews(KsubeditorView *sender);
  /** No descriptions */
  void slotChangeFPS();
  /** No descriptions */
  void slotMoveTime();
  /** No descriptions */

  /** No descriptions */
  void slotConvertCharset();
  /** No descriptions */
  void slotRightClick(QListViewItem* item, const QPoint & point, int);
  /** No descriptions */
  void slotMultiLineEdit(QListViewItem * item);
  /** No descriptions */
  void slotEdit(QListViewItem *, const QPoint &, int );
  /** No descriptions */
  void slotModified();
 
  

private:
    /** the modified flag of the current document */
    bool modified;
    KURL doc_url;
    /** the list of the views currently connected to the document */
    QList<KsubeditorView> *pViewList;	

public: // Public attributes
  /**  */
  int typeDetect(const char * fname);
  /** No descriptions */
  void insert(bool under = false,QListViewItem *to_insert = 0);
  /** No descriptions */
  void delete_(QListViewItem * to_delete);
  /** No descriptions */
  void play();
public: // Public attributes
  /**  */
  int sub_uses_time;
  /**  */
  int format;
  /**  */
  KURL movie_file;

  /**  */
  subtitles * napisy;
  QPopupMenu * right_button_menu;
};

#endif // KSUBEDITORDOC_H
