/***************************************************************************
                          subripper.cpp  -  description
                             -------------------
    begin                : sob sty 11 2003
    copyright            : (C) 2003 by Anatol Ogrek
    email                : mroova@linux.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define READ_ERROR    -2
#define SUB_INVALID   -1
#define SUB_MICRODVD  0
#define SUB_SUBRIP    1
#define SUB_SUBVIEWER 2
#define SUB_SAMI      3
#define SUB_VPLAYER   4
#define SUB_RT        5
#define SUB_SSA       6
#define SUB_DUNNOWHAT 7		// FIXME what format is it ?
#define SUB_MPSUB     8
#define SUB_AQTITLE   9
#define SUB_MAX_TEXT  3
#define LINE_LEN  1000

#include <stdlib.h> 
#include <qfile.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qcombobox.h>

#include <kmessagebox.h>
#include <klocale.h>
#include <kiconloader.h>
 
#include "subripper.h"
#include "configuration.h"

subRipper::subRipper(){
}
subRipper::~subRipper(){
}
/** No descriptions */
subRipper::subRipper(KListView * Lista)
{

  inserting = false;
  col = 3;
  this->Lista = Lista;
  move = configuration::move_SRT;

}
/** No descriptions */
int subRipper::load(QString filename)
{

  int number = 1;
  bool ok = true;
  char line[1000+1];
  QString line1;
  int a, len;
  char a1[4],a2[4],a3[4],a4[4];
  char t1[20],t2[20];
  QListViewItem * item;

  if (!inserting)
  {  
    item = 0;
  } else item = Lista->lastItem();

  QFile *fd = new QFile(filename);

  if (!fd->open(IO_ReadOnly)) return false;

  QTextStream t(fd);

  switch (configuration::defaultEncoding)
  {
    case 0:  break;
    case 1:  t.setEncoding(QTextStream::Unicode);
             break;
    case 2:  t.setEncoding(QTextStream::UnicodeReverse);
             break;
    case 3:  t.setEncoding(QTextStream::Latin1);
             break;
    default:
             t.setCodec(configuration::codecList->at(configuration::defaultEncoding-4) );
             break;
   }

   while (line1 = t.readLine())
   {
     strcpy(line,line1.latin1());

     if (line1.toInt()>0)
     {
       if (item) item = new KListViewItem( Lista, item );
          else item = new KListViewItem( Lista, 0 );
       a = 3;
       item->setRenameEnabled(0,false);
       item->setRenameEnabled(1,true);
       item->setRenameEnabled(2,true);
       item->setRenameEnabled(3,true);
       item->setRenameEnabled(4,true);
       item->setRenameEnabled(5,true);
       if (line1.toInt()!=number) ok = false;
       item->setText(0,QString("%1").arg(number++,0,10));
     } //line with number
     else
       if ((len=sscanf (line, "%s --> %s",t1,t2)) >= 2)
       {
          item->setText(1,t1);
          item->setText(2,t2);
       }  //time
     else
       if (line1!="\r\n")
       {
          item->setText(a++,line1);
       }

  }
  if (!ok) KMessageBox::error (0,i18n("Bad line numbers were found and corrected."), i18n("Bad line numbers"));
  check();
}
/** No descriptions */
bool subRipper::checkLine(QListViewItem * line)
{

  bool ok = false, test;
  char time[12];
  int len,a1,a2,a3,a4;

  if (line)
  {
     if (line->text(1))
     {
        if (line->text(1)) strcpy(time,line->text(1).latin1()); else return false;
        if ((len=sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4)<4)) return false; else ok = true;
        if (line->text(2)) strcpy(time,line->text(2).latin1()); else return false;
        if ((len=sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4)<4)) return false; else ok = true;
        if (line->text(0))
        {
           line->text(0).toLong(&test,10);
           if (!test) return false;
        }
     }
     else return false;
  } else return false;

  return ok;

}
/** No descriptions */
bool subRipper::checkSorted(QListViewItem * item)
{

  char time[30];
  int a1,a2,a3,a4,b1,b2,b3,b4;

  QListViewItem  * dest_item = item->itemBelow();

  if (!dest_item) return false;;
  if ((item->text(2))&&(dest_item->text(1)))
  {
     strcpy(time,item->text(2).latin1());
     sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
     strcpy(time,dest_item->text(1).latin1());
     sscanf (time, "%d:%d:%d,%d",&b1,&b2,&b3,&b4);
     if (a1>b1) return false;
     if ((a1==b1)&&(a2>b2)) return false;
     if ((a1<=b1)&&(a2==b2)&&(a3>b3)) return false;
     if ((a1<=b1)&&(a2<=b2)&&(a3==b3)&&(a4>b4)) return false;
  }

return true;

}
/** No descriptions */
bool subRipper::convert(int dest, KListView * ListView, int fps)
{

   int len,a1,a2,a3,a4;
   KListViewItem  * dest_item;
   int a=1,b;
   dest_item = 0;

   switch (dest)
   {
   case SUB_VPLAYER:
   
        for (QListViewItem  * item = Lista->firstChild();
             item!=0;item = item->itemBelow())
        {

          if (dest_item) dest_item = new KListViewItem( ListView, dest_item );
               else dest_item = new KListViewItem( ListView, 0 );

            dest_item->setRenameEnabled(0,true);
            dest_item->setRenameEnabled(1,true);
            dest_item->setRenameEnabled(2,true);
            dest_item->setRenameEnabled(3,true);

            dest_item->setText(1,item->text(3));
            dest_item->setText(2,item->text(4));
            dest_item->setText(3,item->text(5));
            if (checkLine(item))
            {
              dest_item->setText(0,item->text(1).left(8));
            }
        }
        break;

   case SUB_MICRODVD:
          for (QListViewItem  * item = Lista->firstChild();
               item!=0;item = item->itemBelow())
          {

            if (dest_item) dest_item = new KListViewItem( ListView, dest_item );
                 else dest_item = new KListViewItem( ListView, 0 );

            dest_item->setRenameEnabled(0,true);
            dest_item->setRenameEnabled(1,true);
            dest_item->setRenameEnabled(2,true);
            dest_item->setRenameEnabled(3,true);
            dest_item->setRenameEnabled(4,true);
            dest_item->setText(2,item->text(3));
            dest_item->setText(3,item->text(4));
            dest_item->setText(4,item->text(5));

            if (checkLine(item))
            {
              len=sscanf (item->text(1).latin1(), "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
              dest_item->setText(0,QString("%1").arg(a1*3600*fps+a2*60*fps+a3*fps+(a4/1000.0)*fps,0,'f',0));
              len=sscanf (item->text(2).latin1(), "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
              dest_item->setText(1,QString("%1").arg(a1*3600*fps+a2*60*fps+a3*fps+(a4/1000.0)*fps,0,'f',0));
            }
          }
          break;
 case SUB_SSA:

        dest_item = 0;

        for (QListViewItem  * item = Lista->firstChild();
             item!=0;item = item->itemBelow())
        {

          if (dest_item) dest_item = new KListViewItem( ListView, dest_item );
              else dest_item = new KListViewItem( ListView, 0 );

          dest_item->setRenameEnabled(0,false);
          dest_item->setRenameEnabled(1,true);
          dest_item->setRenameEnabled(2,true);
          dest_item->setRenameEnabled(3,true);
          dest_item->setRenameEnabled(4,true);
          QString w;
          dest_item->setText(3,item->text(2));
          dest_item->setText(4,item->text(3));
          dest_item->setText(5,item->text(4));

          double seconds;
          char h[3],m[3],s[3],ms[4];
          int a1,a2,a3,a4;

          if (checkLine(item))
          {
            for (b = 1;b<3;b++)
            {
              QString string = item->text(b);
              string.replace(8,1,".");
              dest_item->setText(b-1,string);
            }
          }
        }
        break;
     default: return false;
              break;
   }

}
/** No descriptions */
QString subRipper::currentPosition(QListViewItem * item)
{
  QString seconds;

  if (checkLine(item))
  {
     char time[20];
     int len,a1,a2,a3;

     strcpy(time,item->text(1).latin1());
     len=sscanf (time, "%d:%d:%d,",&a1,&a2,&a3);
     seconds.setNum(a1*3600+a2*60+a3-4);
  }
  else seconds = "0";

 return seconds;

}
/** No descriptions */
bool subRipper::moveMs(int secs, bool one)
{

  QString line1;
  QListViewItem  * starting_row;
  int a;
  int len,a1,a2,a3,a4;
  char time[12],h[3],m[3],s[3],ts[4];

  if (!(starting_row = Lista->selectedItem())) starting_row = Lista->firstChild();

  do
  {
    if (checkLine(starting_row))
    {
       for (a = 1;a<3;a++)
       {
         strcpy(time,starting_row->text(a).latin1());
         len=sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
         a4+=secs;

         if (a4>999) {a3++;a4 = a4 -1000;}
         if (a4<0) {a4 = 1000 + a4; a3--;}

         if (a3>59) {a2++;a3 = 60-a3;};
         if (a3<0) {a3=60+a3;a2--;};

         if (a2>59) {a1++;a2 = 60-a2;};
         if (a2<0) {a2 = 60 + a2; a1--;};

         if ((a1>9)||(a1<0)) sprintf(h,"%i",a1); else sprintf(h,"0%i",a1);
         if ((a2>9)||(a2<0)) sprintf(m,"%i",a2); else sprintf(m,"0%i",a2);
         if ((a3>9)||(a3<0)) sprintf(s,"%i",a3); else sprintf(s,"0%i",a3);

         QString str =QString("%1").arg(a4,0,10);
         if (str.length() == 1) str = "00"+str;
         if (str.length() == 2) str = "0"+str;
         starting_row->setText(a, tr2i18n(h)+":"+tr2i18n(m)+":"+tr2i18n(s)+","+tr2i18n(str));
       }
    }

  } while ((starting_row=starting_row->itemBelow())&&(one == false));

  check();

  return true;

}
/** No descriptions */
int subRipper::moveTime(int secs, bool one)
{

 QString line1;
 QListViewItem  * starting_row;
 int a;

 move_sub * movetime = new move_sub();

  if (!secs)
  {
     if (movetime->exec())
     {
        if (movetime->RadioButton3->isChecked())
        {
           starting_row = Lista->firstChild();
        }

        if (movetime->RadioButton4->isChecked())
        {
           starting_row = Lista->selectedItem();
        }
     } else return true;
   }
   else
    if (!(starting_row = Lista->selectedItem())) starting_row = Lista->firstChild();

  int len,a1,a2,a3,a4;
  char time[12],h[3],m[3],s[3],ts[4];

  do
  {
    if (checkLine(starting_row))
    {
       for (a = 1;a<3;a++)
       {
         strcpy(time,starting_row->text(a).latin1());
         len=sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
         if (!secs)
         {
            if (movetime->ComboBox1->currentText() == "Minus")
            {
               a1 = a1 - movetime->hour->value();
               a2 = a2 - movetime->minute->value();
               a3 = a3 - movetime->second->value();
            }
            else
            {
               a1 = a1 + movetime->hour->value();
               a2 = a2 + movetime->minute->value();
               a3 = a3 + movetime->second->value();
            }
          }
          else a3+=secs;

          if (a3>59) {a2++;a3 = a3-60;};
          if (a3<-59) {a2--;a3 = -60-a3;}
          if ((a3<0)&&(a2>0)) {a3 = 60+a3; a2--;}
          if ((a3>0)&&(a2<0)) {a3 = -60+a3; a2++;}
          if ((a3>0)&&(a2==0)&&(a1<0)) {a3 = -60+a3; a2 = -59;a1++;}

          if (a2>59) {a1++;a2 = a2-60 ;};
          if (a2<-59) {a1--;a2 = -60-a2;}
          if ((a2<0)&&(a1>0)) {a2 = 60+a2; a1--;}
          if ((a2>0)&&(a1<0)) {a2 = -60+a2; a1++;}


          if ((a1>9)||(a1<0)) sprintf(h,"%i",a1); else sprintf(h,"0%i",a1);
          if ((a2>9)||(a2<0)) sprintf(m,"%i",a2); else sprintf(m,"0%i",a2);
          if ((a3>9)||(a3<0)) sprintf(s,"%i",a3); else sprintf(s,"0%i",a3);
          if (a4<10) sprintf(ts,"00%i",a4); else
          if (a4<100) sprintf(ts,"0%i",a4); else sprintf(ts,"%i",a4);

          starting_row->setText(a, tr2i18n(h)+":"+tr2i18n(m)+":"+tr2i18n(s)+","+tr2i18n(ts));
       }
    }

  } while ((starting_row=starting_row->itemBelow())&&(one == false));

  check();
  delete movetime;

  return true;


}
/** No descriptions */
bool subRipper::save(QString filename)
{

 QFile * file = new QFile(filename);
 QTextStream t(file);

 if (!file->open(IO_WriteOnly)) return false;

 switch (configuration::defaultEncoding)
 {
    case 0:  break;
    case 1:  t.setEncoding(QTextStream::Unicode);
             break;
    case 2:  t.setEncoding(QTextStream::UnicodeReverse);
             break;
    case 3:  t.setEncoding(QTextStream::Latin1);
             break;
    default:
             t.setCodec(configuration::codecList->at(configuration::defaultEncoding-4) );
             break;
 }

 QString line;

 for (QListViewItem  * item = Lista->firstChild(); item!=0;
      item = item->itemBelow())
 {
   t<<item->text(0)+"\r\n";
   t<<item->text(1)+" --> "+item->text(2)+"\r\n";
   if (item->text(3)) if (item->text(3).length()>0) t<<item->text(3)+"\r\n";
   if (item->text(4)) if (item->text(4).length()>0) t<<item->text(4)+"\r\n";
   if (item->text(5)) if (item->text(5).length()>0) t<<item->text(5)+"\r\n";
   t<<"\r\n";
 }

  file->close();

  return true;

}
/** No descriptions */
void subRipper::setColumns()
{

    Lista->addColumn("Number");
    Lista->addColumn("Start");
    Lista->addColumn("Stop");
    Lista->addColumn("First Line");
    Lista->addColumn("Second Line");
    Lista->addColumn("Third Line");
    Lista->setSorting(-1,false);

}

/*!
    \fn subRipper::setRenaming()
 */
void subRipper::setRenaming()
{
 for (QListViewItem  * item = Lista->firstChild();
              item!=0;item = item->itemBelow())
	{
   		   item->setRenameEnabled(0,false);
           item->setRenameEnabled(1,true);
           item->setRenameEnabled(2,true);
           item->setRenameEnabled(3,true);
           item->setRenameEnabled(4,true);
           item->setRenameEnabled(5,true);

	}

}

