/***************************************************************************
                          vplayer.cpp  -  description
                             -------------------
    begin                : sob sty 11 2003
    copyright            : (C) 2003 by Anatol Ogrek
    email                : mroova@linux.net.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#define READ_ERROR    -2
#define SUB_INVALID   -1
#define SUB_MICRODVD  0
#define SUB_SUBRIP    1
#define SUB_SUBVIEWER 2
#define SUB_SAMI      3
#define SUB_VPLAYER   4
#define SUB_RT        5
#define SUB_SSA       6
#define SUB_DUNNOWHAT 7		// FIXME what format is it ?
#define SUB_MPSUB     8
#define SUB_AQTITLE   9
#define SUB_MAX_TEXT  3
#define LINE_LEN  1000

 
#include <qfile.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qcombobox.h>
#include <stdlib.h>
#include <klocale.h>
#include <kiconloader.h>
#include "vplayer.h" 
#include "configuration.h"

vplayer::vplayer(){
}
vplayer::~vplayer(){
}
/** No descriptions */
int vplayer::load(QString filename)
{

 QListViewItem * item;
 char line[1000+1];
 QString line1;
 QString line2;
 QString line3;
 QString s2;
 int a1,a2,a3;
 char h[3],m[3],s[3], separator;
 int a,b,c, plen, len;

 if (!inserting)
 {
   
    item = 0;
 }
 else
 {
    item = Lista->lastItem();
 }

 QFile *fd = new QFile(filename);
 if (!fd->open(IO_ReadOnly)) return false;
 QTextStream t(fd);

 switch (configuration::defaultEncoding)
 {
   case 0:  break;
   case 1:   t.setEncoding(QTextStream::Unicode);
            break;
   case 2:  t.setEncoding(QTextStream::UnicodeReverse);
            break;
   case 3:  t.setEncoding(QTextStream::Latin1);
            break;
   default:
            t.setCodec(configuration::codecList->at(configuration::defaultEncoding-4) );
            break;
  }

  while (line1 = t.readLine())
  {
    strcpy(line,line1.latin1());

    if (item)
    {
      item = new KListViewItem( Lista, item );
    }
    else item = new KListViewItem( Lista, 0 );

    item->setRenameEnabled(0,true);
    item->setRenameEnabled(1,true);
    item->setRenameEnabled(2,true);
    item->setRenameEnabled(3,true);

    if ((len=sscanf (line, "%d:%d:%d%c%n",&a1,&a2,&a3,&separator,&plen)) >= 4)
    {
      if (a1>9) sprintf(h,"%i",a1); else sprintf(h,"0%i",a1);
      if (a2>9) sprintf(m,"%i",a2); else sprintf(m,"0%i",a2);
      if (a3>9) sprintf(s,"%i",a3); else sprintf(s,"0%i",a3);

      item->setText(0, tr2i18n(h)+":"+tr2i18n(m)+":"+tr2i18n(s));
    }
    else
    {
       plen = 1;
    }

    if (line3 = line1.right(line1.length() - plen))
    {
       a = 0;
       b = 0;
       c = 1;
       while (b!=line3.length())
       {
          b = line3.find('|',a);
          if (b==-1) b = line3.length();
          line2 = line3.mid(a,b-a);
          item->setText(c,line2);
          c++;
          a = b+1;
        }
    }
  }

  fd->close();

  return true;
}
/** No descriptions */
 vplayer::vplayer(KListView * Lista){
   inserting = false;
   col = 1;
   this->Lista = Lista;
}
/** No descriptions */
int vplayer::moveTime(int secs, bool one){

  QString line1;
  QListViewItem  * starting_row;

  movetime = new move_sub(this,"Move",true);

  if (!secs)
  {
    if (movetime->exec())
    {

     if (movetime->RadioButton3->isChecked())
     {
        starting_row = Lista->firstChild();
     }

     if (movetime->RadioButton4->isChecked())
     {
        starting_row = Lista->selectedItem();
     }
    } else return true;
   }
   else
    if (!(starting_row = Lista->selectedItem()))
        starting_row = Lista->firstChild();

 int len,a1,a2,a3;
 char time[12],h[3],m[3],s[3];

  do
  {
   if (checkLine(starting_row))
   {
     strcpy(time,starting_row->text(0).latin1());
     len=sscanf (time, "%d:%d:%d",&a1,&a2,&a3);
     if (!secs)
     {
       if (movetime->ComboBox1->currentText() == "Minus")
       {
          a1 = a1 - movetime->hour->value();
          a2 = a2 - movetime->minute->value();
          a3 = a3 - movetime->second->value();
       }
       else
       {
          a1 = a1 + movetime->hour->value();
          a2 = a2 + movetime->minute->value();
          a3 = a3 + movetime->second->value();
       }
     }  else a3+=secs;

     if (a3>59) {a2++;a3 = a3-60;};

     if (a3<0) {a2--;a3 = 60+a3;}
     if (a2>59) {a1++;a2 = a2-60;};
     if (a2<0) {a1--;a2 = 60+a2;};

     if ((a1>9)||(a1<0)) sprintf(h,"%i",a1); else sprintf(h,"0%i",a1);
     if ((a2>9)||(a2<0)) sprintf(m,"%i",a2); else sprintf(m,"0%i",a2);
     if ((a3>9)||(a3<0)) sprintf(s,"%i",a3); else sprintf(s,"0%i",a3);

     starting_row->setText(0, tr2i18n(h)+":"+tr2i18n(m)+":"+tr2i18n(s));
   }

  } while ((starting_row=starting_row->itemBelow())&&(one == false));

  check();
  delete movetime;

  return true;
}
/** No descriptions */
bool vplayer::checkLine(QListViewItem * line)
{

  bool ok = false;
  char time[12];
  int len,a1,a2,a3;

  if (line)
  {
    if (line->text(0))
    {
      strcpy(time,line->text(0).latin1());
      if ((len=sscanf (time, "%d:%d:%d",&a1,&a2,&a3)<3)) return false;
      else ok = true;
    }
    else return false;
  } else return false;

  return ok;
}
/** No descriptions */
bool vplayer::checkSorted(QListViewItem * item)
{
  int len,a1,a2,a3;
  int b1,b2,b3;
  char time[12];
  QListViewItem *item2;

 item2 = item->itemBelow();
  if (item2)
  {
    if ((item->text(0))&&(item2->text(0)))
    {
      strcpy(time,item->text(0).latin1());
      sscanf (time, "%d:%d:%d",&a1,&a2,&a3);
      strcpy(time,item2->text(0).latin1());
      sscanf (time, "%d:%d:%d",&b1,&b2,&b3);
      if (a1>b1) return false;
      if ((a1==b1)&&(a2>b2)) return false;
      if ((a1==b1)&&(a2==b2)&&(a3>b3)) return false;
      return true;
	 
    } else return false;
  } else return true;

  return true;
}
/** No descriptions */
bool vplayer::save(QString filename)
{
   QFile * file = new QFile(filename);

   if (!file->open(IO_WriteOnly)) return false;

   QTextStream t(file);

   switch (configuration::defaultEncoding)
   {
       case 0:  break;
       case 1:   t.setEncoding(QTextStream::Unicode);
                break;
       case 2:  t.setEncoding(QTextStream::UnicodeReverse);
                break;
       case 3:  t.setEncoding(QTextStream::Latin1);
                break;
       default:
                t.setCodec(configuration::codecList->at(configuration::defaultEncoding-4) );
                break;
   }

  QString line;

  for (QListViewItem  * item = Lista->firstChild();
       item!=0;item = item->itemBelow())
  {
      line = item->text(0)+":";

      if (item->text(1)) line+=item->text(1);
      if (item->text(2)) line+="|"+item->text(2);
      if (item->text(3)) line+="|"+item->text(3);
      line+="\r\n";
      t<<line;
  }

  file->close();

  return true;
}
/** No descriptions */
QString vplayer::currentPosition(QListViewItem * item)
{
  QString seconds;
  
  if (checkLine(item))
  {
     char time[12];
     int len,a1,a2,a3;
     strcpy(time,item->text(0).latin1());
     len=sscanf (time, "%d:%d:%d",&a1,&a2,&a3);
     seconds.setNum(a1*3600+a2*60+a3-4);
  }
  else seconds = "0";

  return seconds;
}
/** No descriptions */
void vplayer::setColumns()
{

    Lista->addColumn("Start time");
    Lista->addColumn("First line");
    Lista->addColumn("Second line");
    Lista->addColumn("Third line");
    Lista->setSorting(-1,false);

}
/** No descriptions */
bool vplayer::convert(int dest, KListView * ListView, int fps)
{

    int len,a1,a2,a3,a4,b1,b2,b3,b4,plen,a=0;
    char h[3],m[3],s[3],time[30];
    char separator;
    KListViewItem  * dest_item;
   switch (dest) {

   case SUB_MICRODVD:
         for (QListViewItem  * item = Lista->firstChild();
              item!=0;item = item->itemBelow())
         {
           if (dest_item) dest_item = new KListViewItem( ListView, dest_item );
                else dest_item = new KListViewItem( ListView, 0 );

           dest_item->setRenameEnabled(0,false);
           dest_item->setRenameEnabled(1,true);
           dest_item->setRenameEnabled(2,true);
           dest_item->setRenameEnabled(3,true);
           dest_item->setRenameEnabled(4,true);

           dest_item->setText(2,item->text(1));
           dest_item->setText(3,item->text(2));
           dest_item->setText(4,item->text(3));
           if (checkLine(item))
           {
              char time[12];
              strcpy(time,item->text(0).latin1());
              len=sscanf (time, "%d:%d:%d%c%n",&a1,&a2,&a3,&separator,&plen);

              char out[12];
              sprintf(out,"%li",(a1*3600+a2*60+a3)*fps);
              dest_item->setText(0, out);
              sprintf(out,"%li",(a1*3600+a2*60+a3)*fps+3*fps);//+3 seconds
              dest_item->setText(1, out);
           }
         }

         for (QListViewItem  * item = ListView->firstChild();//repair stop frame, not to be greater than nex start frame
              item!=0;item = item->itemBelow())
         {
              QListViewItem  * dest_item = item->itemBelow();

              if (!dest_item) break;
              if ((item->text(1))&&(dest_item->text(0)))
              {
                int stop = atol(item->text(1));
                int start = atol(dest_item->text(0));
                if (stop>start) item->setText(1,dest_item->text(0));
               }
         }

     break;

   case SUB_SUBRIP:
         a = 0;
         for (QListViewItem  * item = Lista->firstChild();
              item!=0;item = item->itemBelow())
         {
           if (dest_item) dest_item = new KListViewItem( ListView, dest_item );
                else dest_item = new KListViewItem( ListView, 0 );

           dest_item->setText(0,QString("%1").arg(++a,0,10));
           dest_item->setRenameEnabled(0,true);
           dest_item->setRenameEnabled(1,true);
           dest_item->setRenameEnabled(2,true);
           dest_item->setRenameEnabled(3,true);
           dest_item->setRenameEnabled(4,true);
           dest_item->setRenameEnabled(5,true);
           dest_item->setText(3,item->text(1));
           dest_item->setText(4,item->text(2));
           dest_item->setText(5,item->text(3));

           if (checkLine(item))
           {
              char time[12];
              strcpy(time,item->text(0).latin1());
              len=sscanf (time, "%d:%d:%d%c%n",&a1,&a2,&a3,&separator,&plen);
              a3+=3;

              if (a3>59) {a2++;a3 = 60-a3;};
              if ((a3<0)&&(a2>0)) {a3 = 60+a3; a2--;}
              if ((a3>0)&&(a2<0)) {a3 = -60+a3; a2++;}
              if ((a3>0)&&(a2==0)&&(a1<0)) {a3 = -60+a3; a2 = -59;a1++;}

              if (a2>59) {a1++;a2 = 60-a2;};
              if ((a2<0)&&(a1>0)) {a2 = 60+a2; a1--;}
              if ((a2>0)&&(a1<0)) {a2 = -60+a2; a1++;}

              if ((a1>9)||(a1<0)) sprintf(h,"%i",a1); else sprintf(h,"0%i",a1);
              if ((a2>9)||(a2<0)) sprintf(m,"%i",a2); else sprintf(m,"0%i",a2);
              if ((a3>9)||(a3<0)) sprintf(s,"%i",a3); else sprintf(s,"0%i",a3);

              dest_item->setText(1, item->text(0)+",000");
              dest_item->setText(2, tr2i18n(h)+":"+tr2i18n(m)+":"+tr2i18n(s)+",000");

           }
         }

         for (QListViewItem  * item = ListView->firstChild();//repair stop frame, not to be greater than nex start frame
              item!=0;item = item->itemBelow())
         {
             QListViewItem  * dest_item = item->itemBelow();
             if (!dest_item) break;

             if ((item->text(2))&&(dest_item->text(1)))
             {
               strcpy(time,item->text(2).latin1());
               sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
               strcpy(time,dest_item->text(1).latin1());
               sscanf (time, "%d:%d:%d,%d",&b1,&b2,&b3,&b4);
               if ( ((a3>b3)&&(a2<=b2)) ||(b2<a2) )
                 item->setText(2,dest_item->text(1));
             }
         }
     break;
   case SUB_SSA:
         a = 0;
         for (QListViewItem  * item = Lista->firstChild();
              item!=0;item = item->itemBelow())
         {
           if (dest_item) dest_item = new KListViewItem( ListView, dest_item );
                else dest_item = new KListViewItem( ListView, 0 );

           dest_item->setRenameEnabled(0,true);
           dest_item->setRenameEnabled(1,true);
           dest_item->setRenameEnabled(2,true);
           dest_item->setRenameEnabled(3,true);
           dest_item->setRenameEnabled(4,true);
           dest_item->setText(2,item->text(1));
           dest_item->setText(3,item->text(2));
           dest_item->setText(4,item->text(3));

           if (checkLine(item))
           {
              char time[12];
              strcpy(time,item->text(0).latin1());
              len=sscanf (time, "%d:%d:%d%c%n",&a1,&a2,&a3,&separator,&plen);
              a3+=3;

              if (a3>59) {a2++;a3 = 60-a3;};
              if ((a3<0)&&(a2>0)) {a3 = 60+a3; a2--;}
              if ((a3>0)&&(a2<0)) {a3 = -60+a3; a2++;}
              if ((a3>0)&&(a2==0)&&(a1<0)) {a3 = -60+a3; a2 = -59;a1++;}

              if (a2>59) {a1++;a2 = 60-a2;};
              if ((a2<0)&&(a1>0)) {a2 = 60+a2; a1--;}
              if ((a2>0)&&(a1<0)) {a2 = -60+a2; a1++;}

              if ((a1>9)||(a1<0)) sprintf(h,"%i",a1); else sprintf(h,"0%i",a1);
              if ((a2>9)||(a2<0)) sprintf(m,"%i",a2); else sprintf(m,"0%i",a2);
              if ((a3>9)||(a3<0)) sprintf(s,"%i",a3); else sprintf(s,"0%i",a3);

              dest_item->setText(0, item->text(0)+".00");
              dest_item->setText(1, tr2i18n(h)+":"+tr2i18n(m)+":"+tr2i18n(s)+".00");

           }
         }

         for (QListViewItem  * item = ListView->firstChild();//repair stop frame, not to be greater than nex start frame
              item!=0;item = item->itemBelow())
         {
             QListViewItem  * dest_item = item->itemBelow();
             if (!dest_item) break;

             if ((item->text(0))&&(dest_item->text(1)))
             {
               strcpy(time,item->text(1).latin1());
               sscanf (time, "%d:%d:%d,%d",&a1,&a2,&a3,&a4);
               strcpy(time,dest_item->text(0).latin1());
               sscanf (time, "%d:%d:%d,%d",&b1,&b2,&b3,&b4);
               if ( ((a3>b3)&&(a2<=b2)) ||(b2<a2) )
                 item->setText(1,dest_item->text(0));
             }
         }
     break;
   default: return false;
     break;
  }


}

/*!
    \fn vplayer::setRenaming()
 */
void vplayer::setRenaming()
{
    for (QListViewItem  * item = Lista->firstChild();
              item!=0;item = item->itemBelow())
	{
   		   item->setRenameEnabled(0,true);
           item->setRenameEnabled(1,true);
           item->setRenameEnabled(2,true);
           item->setRenameEnabled(3,true);
	}

}

